#include <avr/io.h>
#include <util/delay.h>

//-------------------------------------------------------------------------------------
//mesure
//-------------------------------------------------------------------------------------
uint16_t can_mesure(uint8_t voie,uint8_t noise_reduction)
{
volatile uint16_t res;

//aden=0 arret
ADCSRA &= ~_BV(ADEN);

//multiplexage (choix de la voie)
ADMUX=0+voie;

//ADC noise reduction
if (noise_reduction!=0)
{
MCUCR=16;
}

//aden=1 mise en route
ADCSRA = 128+4+1;

//debut conversion
ADCSRA |= _BV(ADSC);

//attente fin de conversion
while ((ADCSRA & 64)!=0)
{
}

//conversion
res=ADCL+ADCH*256;

return res;
}




